#################### SETUP TAXSET ##########################

#########VARIABLES#############
#BEGIND = 23883 = The first I# folder within the TaxonSet folder; don't include the "I"
#ENDIND = 23927 = The last I# folder within the TaxonSet folder; don't include the "I"
#MINREADS = 20 = Minimum number of read coverage a locus must have to pass filter. Threshold found with plot generated by R identifyGoodSeqs
#ASSEMBLEDLOCI = 517 = Number of loci in probe design; found in Project's Assembly Methods
#TAXSET = T350 = "T#"
#NTHREADS = 26 = Number of threads/processors you want to use
#PLOIDYTAIL = C = determines whether to use PloidyspecificationFile_2 or PloidyspecificationFile_C
#MINSEQS = 20 = Minimum number of individuals a locus must have to pass filter, typically 1/2 the sample size
#NSCRIPTS = 26 = Number of cripts to run
#FOLDERTAIL = _conSeqs = foldertail of prealignments, alignments, trimmedalignments, and RAxML folders. Typically either "_conSeqs" or "_2alleles" depending on consensus sequences or phased alleles
#NEWNLOCI = 382 = New number of Loci _____; printed out after java SortSequencesViaOrthoSetsC. Locus conversion chart is found in prealignments folder
#NEWNTAXA = 41 = Number of samples. 2X the number of individuals/samples if Phased for 2 alleles.
#MISSINGALLOWED = 15 = Number of Missing sequences for alignments to tolerate. Typically 1/4 of NEWNTAXA 
#COLLABNAME = Sytsma = Collaborator's name
#LINUX = LIN.UX = Last 3 digits of IP adress of machine that the Taxonset is stored on
#STORNUM = STOR.NUM = Storage number that the Taxonset is stored on
#DRIVENAME = DRIVE.NAME = Drive that the Taxonset will be offloaded to


###IF YOU DEVIATE FROM THIS TEMPLATE WRITE DOWN ANY CHANGES######

#This taxon set was done on LinuxIP LIN.UX






#YOU SHOULD BE IN THE TAXSET FOLDER ON THE STORAGE DRIVE
mkdir Results
mkdir Code
cd Code
cp '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/EvalInformativeSitesInPhylipMatrix.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/GatherALLConSeqsWithOKCoverage2.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/GetPairwiseDistanceMeasures.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/IdentifyGoodSeqsViaReadsMappedC.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/PlotAlignmentSummary2.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/plotMDS5.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/plotMDS5par.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/SetupRAxML3.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/SortSequencesViaOrthoSetsC.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/toTaxonDrive.sh' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/TrimAndMaskRawAlignments3.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/writeOrthologyScript.sh' .

#IDENTIFY CONSENSUS SEQUENCES PASSING COVERAGE FILTER
R
source("IdentifyGoodSeqsViaReadsMappedC.r")
#identifyGoodSeqs(BEGIND,ENDIND,NHOMOLOGSTOCONSIDER,MINREADS)
#Threshold should be the 5th percentile (Blue line). Move Red line as close to Blue line as possible. 
identifyGoodSeqs(20025,23927,6,100)
quit()

#USE HOMOLOG IDS TO OBTAIN GOOD HOMOLOG SEQUENCES TO PUT IN HOMOLOGS FOLDER
#java -Xmx4000m GatherALLConSeqsWithOKCoverage2 ../TAXSET.txt ASSEMBLEDLOCI MINREADS
java -Xmx4000m GatherALLConSeqsWithOKCoverage2 ../T350.txt 517 20

#USE INFO IN HOMOLOGS FOLDER TO GENERATE DISTANCE MATRICIES
#java -Xmx4000m GetPairwiseDistanceMeasures TAXSET ASSEMBLEDLOCI KMERSIZE
java -Xmx4000m GetPairwiseDistanceMeasures T350 517 20




########################## ORTHOLOGY ##########################
#USE DISTANCE MEASURES TO IDENTIFY ORTHOLOGOUS SETS
mkdir ../OrthoSets
chmod +x writeOrthologyScript.sh
./writeOrthologyScript.sh T350 517 26
chmod +x *Ortho*.sh
./allOrthoScripts.sh
./concatOrthology.sh

#SORT THE SEQUENCES INTO ORTHOLOGOUS SETS AND SETUP ALIGNMENTS
#MAKE SURE TO EDIT OR CHOOSE THE APPROPRIATE TAXSET PLOIDY SPECIFICATION FILE FOR THE CORRECT PHASED ALLELES
#java SortSequencesViaOrthoSetsC TAXSET SEQUENCESPECIFICATIONS MINSEQS NSCRIPTS FOLDERTAIL
java SortSequencesViaOrthoSetsC T350 ../T350_PloidySpecificationFile_C.txt 20 26 _conSeqs



########################## ALIGNMENT ##########################
#CHANGE PERMISSIONS
chmod +x *.sh
for i in {1..26}; do run-in-new-tab ./Align_AllViaMAFFT_conSeqs_${i}.sh; done;



########################## TRIMMING ##########################
#note the following block will be repeated until the following parameters are optimized: MINPROPSAME, MINGOODSITES, MISSINGALLOWED
#java TrimAndMaskRawAlignments3 TAXSET NEWNLOCI NEWNTAXA WINDOWSIZE MINGOODSITES MINPROPSAME MISSINGALLOWED ../TAXSET_LociAndTaxaToRemove.txt FOLDERTAIL
java TrimAndMaskRawAlignments3 T350 369 47 20 14 0.4 25 ../T350_LociAndTaxaToRemove.txt _conSeqs

#Rscript PlotAlignmentSummary2.r TAXSET NEWNTAXA NEWNLOCI MISSINGALLOWED FOLDERTAIL
Rscript PlotAlignmentSummary2.r "T350" 47 369 25 "_conSeqs"

#Look at plot Results/TAXSET_AlignmentSummary_nLoci.pdf adjust MISSINGALLOWED so it corrsponds to plateau
#Look at plot Results/TAXSET_AlignmentSummary_MaxTally.pdf adjust MINPROPSAME so it corrsponds to valley
#Look at plot Results/TAXSET_AlignmentSummary_WindowTally.pdf adjust MINGOODSITES so it corrsponds to valley

#java SetupRAxML3 TAXSET NEWNLOCI RAXMLJOBS RAXMLJOBS BOOTS BOOTS OUTGROUPTAXON1,OUTGROUPTAXON2 FOLDERTAIL
java SetupRAxML3 T350 369 6 6 100 100 _conSeqs

#Load RAxML/TAXSET_ConcatLoci.phylip in Geneious and inspect the alignment
#Increasing MINGOODSITES will increase masking.
#Increasing MINPROPSAME will increase trimming.

#Remove any bad loci or individuals in TAXSET_LociAndTaxaToRemove.txt
#Check RAxML_FOLDERTAIL/TAXSET_ConcatLoci.charSets to see which locus number needs to be removed
#Format:
LociNumber	Individual
348			ALL				#Removes locus 348 for all individuals.
ALL			21				#Removes all loci for individual 21. This means the 21st individual in Geneious.

#RUN ALL TRIMMING STEPS AGAIN IF BAD SEQUENCES IDENTIFIED



########################## PHYLOGENETICS ##########################
#SUMMARIZE FINAL ALIGNMENT
java EvalInformativeSitesInPhylipMatrix ../RAxML_conSeqs/T350_ConcatLoci.phylip > ../RAxML_conSeqs/T350_Statistics.txt

#OPEN TO SEE THE STATS
gedit ../RAxML_conSeqs/T350_Statistics.txt

#CHANGE DIRECTORIES AND PERMISSIONS
cd ../RAxML_conSeqs
chmod +x *.sh



############## CONCATENATED TREES ##############
./T350_ConcatLoci.sh



################ SEPARATE TREES ################
./T350_SeparateLoci.sh



#OPEN RAxML_bipartitions.TAXSET_ConcatLoci IN FIGTREE AND SAVE AS TAXSET_Tree.pdf



################# ASTRAL TREES #################
#MAKE ASTRAL FOLDER
mkdir ../Astral
cd ../Code
rsync -av --progress /home/alemmon/Dropbox/Anchor_Bioinformatics/Code/lib /home/alemmon/Dropbox/Anchor_Bioinformatics/Code/astral.4.9.7.jar .

#CONCATENATE EACH BESTTREE LOCI INTO ONE FILE
cat ../RAxML_conSeqs/RAxML_bestTree.T350_L* > ../Astral/RAxML_bestTree.T350_ALL.txt
#CONCATENATE EACH BOOTSTRAP LOCI INTO ONE FILE 
ls -d -1 ../RAxML_conSeqs/RAxML_bootstrap.T350_L* > ../Astral/bs-files

#RUN ASTRAL
java -jar astral.4.9.7.jar -i ../Astral/RAxML_bestTree.T350_ALL.txt -b ../Astral/bs-files -t 1 -o ../Astral/T350_Astral.tre

#OPEN IN FIGTREE AND MAKE PDF TREE
tail -n 1 ../Astral/T350_Astral.tre > ../Astral/AstralTree.tre



######################UPLOADING TO DROPBOX##########################
mkdir /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae
mkdir /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae/RAxML_conSeqs

#zip RAxMLFOLDERTAIL and upload files to TAXSET_COLLABNAME/RAxML DROPBOXFOLDER
run-in-new-tab cd /media/alemmon/storage*/T350
tar -zcvf RAxML_conSeqs.tar.gz RAxML_conSeqs
tar -zcvf Prealignments_conSeqs.tar.gz Prealignments_conSeqs
tar -zcvf Alignments_conSeqs.tar.gz Alignments_conSeqs
tar -zcvf TrimmedAlignments_conSeqs.tar.gz TrimmedAlignments_conSeqs
rsync -av --progress RAxML_conSeqs.tar.gz T350_ConcatTree.pdf /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae/RAxML_conSeqs
cd RAxML_*
rsync -av --progress T350_ConcatLoci.charSets T350_ConcatLoci.phylip T350_Statistics.txt RAxML_bipartitions.T350_ConcatLoci  /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae/RAxML_conSeqs

#Upload Astral folder to TAXSET_COLLABNAME
rsync -av --progress ../Astral /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae



#MAKE SURE THE FOLLOWING FILES ARE ON DROPBOX

# FOR CONCATENATED TREES
# RAxML_conSeqs.zip
# TAXSET_ConcatLoci.charSets
# TAXSET_ConcatLoci.phylip
# TAXSET_Statistics.txt
#  RAxML_bipartitions.TAXSET_ConcatLoci 
#  TAXSET_Tree.pdf 


# FOR SEPARATE TREES
# RAxMLFOLDERTAIL.zip
# TAXSET_ConcatLoci.charSets
# TAXSET_ConcatLoci.phylip
# TAXSET_Statistics.txt


# FOR ASTRAL TREES
# Astral/bs-files
# Astral/RAxML_bestTree.TAXSET_ALL.txt
# Astral/TAXSET_Astral.tre
# Astral/AstralTree.tre
# Astral/AstralTree.pdf



##########################BACKUP DATA TAXONSET AND PROJECT DRIVES##########################
#Compress I numbers and move whole taxonset to Project Drive
#Upload to TaxonSets Drive
mkdir ../Samples
rsync -av --progress ../I* ../Samples
tar -zcvf ../Samples.tar.gz ../Samples
rm -r ../Samples
rsync -avz --exclude 'I*' /media/alemmon/storage*/T350 alemmon@128.186.21.179:/Volumes/TaxonSets

#Upload to Collaborator ProjectDrive
rsync -avz --exclude 'I*' /media/alemmon/storage*/T350 alemmon@128.186.21.179:/Volumes/DRIVE.NAME



#####################################################################################################
##############################################July-28-2017###########################################
#####################################################################################################

#Jeff Rose wanted to add poor quality samples into Taxon Set to determine if they would work.


#################### SETUP TAXSET ##########################

#########VARIABLES#############
#BEGIND = 23883 = The first I# folder within the TaxonSet folder; don't include the "I"
#ENDIND = 23927 = The last I# folder within the TaxonSet folder; don't include the "I"
#MINREADS = 20 = Minimum number of read coverage a locus must have to pass filter. Threshold found with plot generated by R identifyGoodSeqs
#ASSEMBLEDLOCI = 517 = Number of loci in probe design; found in Project's Assembly Methods
#TAXSET = T350 = "T#"
#NTHREADS = 26 = Number of threads/processors you want to use
#PLOIDYTAIL = C = determines whether to use PloidyspecificationFile_2 or PloidyspecificationFile_C
#MINSEQS = 20 = Minimum number of individuals a locus must have to pass filter, typically 1/2 the sample size
#NSCRIPTS = 26 = Number of cripts to run
#FOLDERTAIL = _conSeqs = foldertail of prealignments, alignments, trimmedalignments, and RAxML folders. Typically either "_conSeqs" or "_2alleles" depending on consensus sequences or phased alleles
#NEWNLOCI = 382 = New number of Loci _____; printed out after java SortSequencesViaOrthoSetsC. Locus conversion chart is found in prealignments folder
#NEWNTAXA = 41 = Number of samples. 2X the number of individuals/samples if Phased for 2 alleles.
#MISSINGALLOWED = 15 = Number of Missing sequences for alignments to tolerate. Typically 1/4 of NEWNTAXA 
#COLLABNAME = Sytsma = Collaborator's name
#LINUX = LIN.UX = Last 3 digits of IP adress of machine that the Taxonset is stored on
#STORNUM = STOR.NUM = Storage number that the Taxonset is stored on
#DRIVENAME = DRIVE.NAME = Drive that the Taxonset will be offloaded to


###IF YOU DEVIATE FROM THIS TEMPLATE WRITE DOWN ANY CHANGES######

#This taxon set was done on LinuxIP LIN.UX



#YOU SHOULD BE IN THE TAXSET FOLDER ON THE STORAGE DRIVE
mkdir Results
mkdir Code
cd Code
cp '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/EvalInformativeSitesInPhylipMatrix.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/GatherALLConSeqsWithOKCoverage2.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/GetPairwiseDistanceMeasures.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/IdentifyGoodSeqsViaReadsMappedC.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/PlotAlignmentSummary2.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/plotMDS5.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/plotMDS5par.r' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/SetupRAxML3.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/SortSequencesViaOrthoSetsC.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/toTaxonDrive.sh' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/TrimAndMaskRawAlignments3.class' '/home/alemmon/Dropbox/Anchor_Bioinformatics/Code/writeOrthologyScript.sh' .

#IDENTIFY CONSENSUS SEQUENCES PASSING COVERAGE FILTER
R
source("IdentifyGoodSeqsViaReadsMappedC.r")
#identifyGoodSeqs(BEGIND,ENDIND,NHOMOLOGSTOCONSIDER,MINREADS)
#Threshold should be the 5th percentile (Blue line). Move Red line as close to Blue line as possible. 
identifyGoodSeqs(20025,23927,6,100)
quit()

#USE HOMOLOG IDS TO OBTAIN GOOD HOMOLOG SEQUENCES TO PUT IN HOMOLOGS FOLDER
#java -Xmx4000m GatherALLConSeqsWithOKCoverage2 ../TAXSET.txt ASSEMBLEDLOCI MINREADS
java -Xmx4000m GatherALLConSeqsWithOKCoverage2 ../T350.txt 517 20

#USE INFO IN HOMOLOGS FOLDER TO GENERATE DISTANCE MATRICIES
#java -Xmx4000m GetPairwiseDistanceMeasures TAXSET ASSEMBLEDLOCI KMERSIZE
java -Xmx4000m GetPairwiseDistanceMeasures T350 517 20




########################## ORTHOLOGY ##########################
#USE DISTANCE MEASURES TO IDENTIFY ORTHOLOGOUS SETS
mkdir ../OrthoSets
chmod +x writeOrthologyScript.sh
./writeOrthologyScript.sh T350 517 26
chmod +x *Ortho*.sh
./allOrthoScripts.sh
./concatOrthology.sh

#SORT THE SEQUENCES INTO ORTHOLOGOUS SETS AND SETUP ALIGNMENTS
#MAKE SURE TO EDIT OR CHOOSE THE APPROPRIATE TAXSET PLOIDY SPECIFICATION FILE FOR THE CORRECT PHASED ALLELES
#java SortSequencesViaOrthoSetsC TAXSET SEQUENCESPECIFICATIONS MINSEQS NSCRIPTS FOLDERTAIL
java SortSequencesViaOrthoSetsC T350 ../T350_PloidySpecificationFile_C.txt 20 26 _conSeqs



########################## ALIGNMENT ##########################
#CHANGE PERMISSIONS
chmod +x *.sh
for i in {1..26}; do run-in-new-tab ./Align_AllViaMAFFT_conSeqs_${i}.sh; done;



########################## TRIMMING ##########################
#note the following block will be repeated until the following parameters are optimized: MINPROPSAME, MINGOODSITES, MISSINGALLOWED
#java TrimAndMaskRawAlignments3 TAXSET NEWNLOCorthologsI NEWNTAXA WINDOWSIZE MINGOODSITES MINPROPSAME MISSINGALLOWED ../TAXSET_LociAndTaxaToRemove.txt FOLDERTAIL
java TrimAndMaskRawAlignments3 T350 370 49 20 14 0.4 25 ../T350_LociAndTaxaToRemove.txt _conSeqs

#Rscript PlotAlignmentSummary2.r TAXSET NEWNTAXA NEWNLOCI MISSINGALLOWED FOLDERTAIL
Rscript PlotAlignmentSummary2.r "T350" 49 370 25 "_conSeqs"

#Look at plot Results/TAXSET_AlignmentSummary_nLoci.pdf adjust MISSINGALLOWED so it corrsponds to plateau
#Look at plot Results/TAXSET_AlignmentSummary_MaxTally.pdf adjust MINPROPSAME so it corrsponds to valley
#Look at plot Results/TAXSET_AlignmentSummary_WindowTally.pdf adjust MINGOODSITES so it corrsponds to valley

#java SetupRAxML3 TAXSET NEWNLOCI RAXMLJOBS RAXMLJOBS BOOTS BOOTS OUTGROUPTAXON1,OUTGROUPTAXON2 FOLDERTAIL
java SetupRAxML3 T350 369 6 6 100 100 _conSeqs

#Load RAxML/TAXSET_ConcatLoci.phylip in Geneious and inspect the alignment
#Increasing MINGOODSITES will increase masking.
#Increasing MINPROPSAME will increase trimming.

#Remove any bad loci or individuals in TAXSET_LociAndTaxaToRemove.txt
#Check RAxML_FOLDERTAIL/TAXSET_ConcatLoci.charSets to see which locus number needs to be removed
#Format:
LociNumber	Individual
348			ALL				#Removes locus 348 for all individuals.
ALL			21				#Removes all loci for individual 21. This means the 21st individual in Geneious.

#RUN ALL TRIMMING STEPS AGAIN IF BAD SEQUENCES IDENTIFIED



########################## PHYLOGENETICS ##########################
#SUMMARIZE FINAL ALIGNMENT
java EvalInformativeSitesInPhylipMatrix ../RAxML_conSeqs/T350_ConcatLoci.phylip > ../RAxML_conSeqs/T350_Statistics.txt

#OPEN TO SEE THE STATS
gedit ../RAxML_conSeqs/T350_Statistics.txt

#CHANGE DIRECTORIES AND PERMISSIONS
cd ../RAxML_conSeqs
chmod +x *.sh



############## CONCATENATED TREES ##############
./T350_ConcatLoci.sh



################ SEPARATE TREES ################
./T350_SeparateLoci.sh



#OPEN RAxML_bipartitions.TAXSET_ConcatLoci IN FIGTREE AND SAVE AS TAXSET_Tree.pdf



################# ASTRAL TREES #################
#MAKE ASTRAL FOLDER
mkdir ../Astral
cd ../Code
rsync -av --progress /home/alemmon/Dropbox/Anchor_Bioinformatics/Code/lib /home/alemmon/Dropbox/Anchor_Bioinformatics/Code/astral.4.9.7.jar .

#CONCATENATE EACH BESTTREE LOCI INTO ONE FILE
cat ../RAxML_conSeqs/RAxML_bestTree.T350_L* > ../Astral/RAxML_bestTree.T350_ALL.txt
#CONCATENATE EACH BOOTSTRAP LOCI INTO ONE FILE 
ls -d -1 ../RAxML_conSeqs/RAxML_bootstrap.T350_L* > ../Astral/bs-files

#RUN ASTRAL
java -jar astral.4.9.7.jar -i ../Astral/RAxML_bestTree.T350_ALL.txt -b ../Astral/bs-files -t 1 -o ../Astral/T350_Astral.tre

#OPEN IN FIGTREE AND MAKE PDF TREE
tail -n 1 ../Astral/T350_Astral.tre > ../Astral/AstralTree.tre



######################UPLOADING TO DROPBOX##########################
mkdir /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae
mkdir /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae/RAxML_conSeqs

#zip RAxMLFOLDERTAIL and upload files to TAXSET_COLLABNAME/RAxML DROPBOXFOLDER
run-in-new-tab cd /media/alemmon/storage*/T350
tar -zcvf RAxML_conSeqs.tar.gz RAxML_conSeqs
tar -zcvf Prealignments_conSeqs.tar.gz Prealignments_conSeqs
tar -zcvf Alignments_conSeqs.tar.gz Alignments_conSeqs
tar -zcvf TrimmedAlignments_conSeqs.tar.gz TrimmedAlignments_conSeqs
rsync -av --progress RAxML_conSeqs.tar.gz T350_ConcatTree.pdf /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae/T350_Update/RAxML_conSeqs
cd RAxML_*
rsync -av --progress T350_ConcatLoci.charSets T350_ConcatLoci.phylip T350_Statistics.txt RAxML_bipartitions.T350_ConcatLoci  /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae/T350_Update/RAxML_conSeqs

#Upload Astral folder to TAXSET_COLLABNAME
rsync -av --progress ../Astral /home/alemmon/Dropbox/Anchor_Bioinformatics/TaxonSets/Results/T350_Sytsma_Polemoniaceae



#MAKE SURE THE FOLLOWING FILES ARE ON DROPBOX

# FOR CONCATENATED TREES
# RAxML_conSeqs.zip
# TAXSET_ConcatLoci.charSets
# TAXSET_ConcatLoci.phylip
# TAXSET_Statistics.txt
#  RAxML_bipartitions.TAXSET_ConcatLoci 
#  TAXSET_Tree.pdf 


# FOR SEPARATE TREES
# RAxMLFOLDERTAIL.zip
# TAXSET_ConcatLoci.charSets
# TAXSET_ConcatLoci.phylip
# TAXSET_Statistics.txt


# FOR ASTRAL TREES
# Astral/bs-files
# Astral/RAxML_bestTree.TAXSET_ALL.txt
# Astral/TAXSET_Astral.tre
# Astral/AstralTree.tre
# Astral/AstralTree.pdf



##########################BACKUP DATA TAXONSET AND PROJECT DRIVES##########################
#Compress I numbers and move whole taxonset to Project Drive
#Upload to TaxonSets Drive
mkdir ../Samples
rsync -av --progress ../I* ../Samples
tar -zcvf ../Samples.tar.gz ../Samples
rm -r ../Samples
rsync -avz --exclude 'I*' /media/alemmon/storage*/T350 alemmon@128.186.21.179:/Volumes/TaxonSets

#Upload to Collaborator ProjectDrive
rsync -avz --exclude 'I*' /media/alemmon/storage*/T350 alemmon@128.186.21.179:/Volumes/DRIVE.NAME




